//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "HotkeyCfgPanel.h"
#include "HotKeyConf.h"
#include "KeybKeys.h"
#include "Settings.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(THotkeyCfgPanel *)
{
	static HotKeyConf cfg;
	new THotkeyCfgPanel(NULL, cfg);
}
//---------------------------------------------------------------------------
__fastcall THotkeyCfgPanel::THotkeyCfgPanel(TComponent* Owner, HotKeyConf &cfg)
	: TPanel(Owner),
	cfg(cfg)
{
	Width = 540;
	Height = 32;

	int left = 8;

	cbCtrl = new TCheckBox(this);
	cbCtrl->Parent = this;
	cbCtrl->Left = left;
	cbCtrl->Top = 8;
	//cbCtrl->Caption = "Ctrl";
	cbCtrl->Visible = true;

	left += 24;
	cbShift = new TCheckBox(this);
	cbShift->Parent = this;
	cbShift->Left = left;
	cbShift->Top = 8;
	//cbShift->Caption = "Shift";
	cbShift->Visible = true;

	left += 24;
	cbAlt = new TCheckBox(this);
	cbAlt->Parent = this;
	cbAlt->Left = left;
	cbAlt->Top = 8;
	//cbAlt->Caption = "Alt";
	cbAlt->Visible = true;

	left += 24;
	cbKey = new TComboBox(this);
	cbKey->Parent = this;
	cbKey->Left = left;
	cbKey->Top = 5;
	cbKey->Width = 160;
	cbKey->Style = Stdctrls::csDropDownList;
	cbKey->Visible = true;

	left += cbKey->Width + 30;
	cbAction = new TComboBox(this);
	cbAction->Parent = this;
	cbAction->Left = left;
	cbAction->Top = 5;
	cbAction->Width = 100;
	cbAction->Style = Stdctrls::csDropDownList;
	cbAction->Visible = true;

	left += cbAction->Width + 20;
	cbId = new TComboBox(this);
	cbId->Parent = this;
	cbId->Left = left;
	cbId->Top = 5;
	cbId->Width = 40;
	cbId->Style = Stdctrls::csDropDownList;
	cbId->Visible = true;

	left += cbId->Width + 30;
	btnRemove = new TButton(this);
	btnRemove->Parent = this;
	btnRemove->Left = left;
	btnRemove->Top = 5;
	btnRemove->Width = 24;
	btnRemove->Height = 20;
	btnRemove->Caption = "X";
	btnRemove->Visible = true;
}

void __fastcall THotkeyCfgPanel::UpdateCfg(TObject *Sender)
{
	cfg.modifiers = 0;
	if (cbCtrl->Checked)
		cfg.modifiers |= HotKeyConf::CTRL;
	if (cbShift->Checked)
		cfg.modifiers |= HotKeyConf::SHIFT;
	if (cbAlt->Checked)
		cfg.modifiers |= HotKeyConf::ALT;
	if (cbKey->ItemIndex >= 0)
		cfg.keyCode = vkey_list[cbKey->ItemIndex].name;
	else
		cfg.keyCode = "";
	int id = vkey_find(cfg.keyCode.c_str());
	if (id >= 0)
	{
		cfg.vkCode = vkey_list[id].vkey;
	}
	else
	{
    	cfg.vkCode = -1;
	}
	cfg.action.type = static_cast<Action::Type>(cbAction->ItemIndex);
	cfg.action.id = cbId->ItemIndex;
}

void THotkeyCfgPanel::Start(void)
{
	cbCtrl->OnClick = NULL;
	cbShift->OnClick = NULL;
	cbAlt->OnClick = NULL;
	cbKey->OnChange = NULL;
	cbAction->OnChange = NULL;
	cbId->OnChange = NULL;

	for (int i=0; i<vkey_list_size(); i++)
	{
    	cbKey->Items->Add(vkey_list[i].description);
	}
	for (int i=0; i<Action::TYPE_LIMITER; i++)
	{
    	cbAction->Items->Add(Action::getTypeDescription(static_cast<Action::Type>(i)));
	}
	for (int i=0; i<(1+Settings::EXT_CONSOLE_COLUMNS)*(Settings::CONSOLE_BTNS_PER_COLUMN); i++)
	{
    	cbId->Items->Add(i);
	}

	cbCtrl->Checked = cfg.modifiers & HotKeyConf::CTRL;
	cbShift->Checked = cfg.modifiers & HotKeyConf::SHIFT;
	cbAlt->Checked = cfg.modifiers & HotKeyConf::ALT;
	cbKey->ItemIndex = vkey_find(cfg.keyCode.c_str());	// can't do this in constructor
	cbAction->ItemIndex = cfg.action.type;
	cbId->ItemIndex = cfg.action.id;

	cbCtrl->OnClick = UpdateCfg;
	cbShift->OnClick = UpdateCfg;
	cbAlt->OnClick = UpdateCfg;
	cbKey->OnChange = UpdateCfg;
	cbAction->OnChange = UpdateCfg;
	cbId->OnChange = UpdateCfg;
}

//---------------------------------------------------------------------------
namespace Hotkeycfgpanel
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(THotkeyCfgPanel)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------
